var scriptpath=getScriptRootPath();
var config={
    APPNAME: '福建体育职业技术学院学生版',
    SERVER_URL:'http://120.35.8.172:889/studentportal.php?1=1&apptype=2',
    SERVER_ROOT_URL: 'http://120.35.8.172:889',
    APPTYPE: 1,     //1: 原生h5, 2: 南京苏迪, 3:apicloud
};

//前置模块加载完毕后回调. 前端html的任何js操作都应该在此回调后执行
function onReady(callback, extend) {
    initBefore(extend);  //初始化检测
    switch (config.APPTYPE){
        case 1:
            window.onload=function () {
                initAfter();
                callback(function () {});
            };
            break;
        case 2:
            if (iPortal.isReady) {
                initAfter();
                $('.typehide').attr('class', '');
                callback(function () {});
            } else {
                iPortal.onReady = function() {
                    initAfter();
                    $('.typehide').attr('class', '');
                    callback(function () {});
                }
            }
            break;
        case 3:
            window.onload=function () {
                initAfter();
                callback(function () {});
            }
    }

}

//===================================app版本支持=============================================

function initAfter() {  //初始化后. 主要作用于窗口已完全加载完毕后, 以及js都已成功插入后的通用性操作


    switch(config.APPTYPE){
        case 1:
            break;
        case 2:
            //如果是起始页监听返回事件
            if(checkMain()){
                window.addEventListener('iPortalBack', function(e){
                    event.cancelBehavior = true;
                    iPortal.closeWindow();
                });
            }
            break;
        case 3:
/*            if(checkMain()){
                exitApp();
            }*/
            break;

    }


}

function initBefore(extend) {  //初始化前. 主要用于动态插入js以及最前置需求
    Import(scriptpath+'doT.js');
    Import(scriptpath+'sui/zepto.min.js');
    Import(scriptpath+'sui/sm.min.js');
    Import(scriptpath+'sui/sm-extend.min.js');
    Import(scriptpath+'extra/store.legacy.min.js');
    if(extend!=undefined)
        Import(scriptpath+extend);


    switch(config.APPTYPE){
        case 1:
            break;
        case 2:
            if(window.iPortal==undefined){
                Import(scriptpath+'extra/SHA1.js');
                window.iPortal = {
                    "sudyInitCallback" : (function() {
                        var init = false;
                        return function(context) {
                            if (init) {
                                return init;
                            }
                            init = true;
                            window.iPortal.context = context;
                            var script = document.createElement('script');
                            script.type = 'text/javascript';
                            script.src = context.libPath;
                            script.charset = "utf-8";
                            document.getElementsByTagName("head")[0].appendChild(script);
                            return init;
                        };
                    })()
                };
            }
            break;
        case 3:
            break;
    }
}

function exitApp(){

    api.addEventListener({

        name: 'keyback'

    }, function(ret, err){

        api.toast({

            msg: '再按一次返回键退出',

            duration:1500,

            location: 'bottom'

        });

        api.addEventListener({

            name: 'keyback'

        }, function(ret, err){

            api.closeWidget({

                id: api.appId, //这里改成自己的应用ID

                retData: {name:'closeWidget'},

                silent:true

            });

        });

        setTimeout(function(){

            exitApp();

        },1500)

    });

}

//检测是否为主页(主要目的是为了在主页点击返回键退出, 当前是通过读取body标签的data-main属性判断)
function checkMain() {
    return document.getElementsByTagName("body")[0].dataset['main']=="true";
}

//登录验证失效的响应
function authError() {
    switch(config.APPTYPE){
        case 1:
           // window.location.href=scriptpath+'../html/login.html';
		   window.location.href=scriptpath.substring(0, scriptpath.lastIndexOf('/')-6)+'html/login.html';
            break;
        case 2:
            $.toast('登录失效!请重新登录');
            setTimeout(function () {
                iPortal.closeWindow();
            }, 2000);
            break;
        case 3:
            window.location.href=scriptpath.substring(0, scriptpath.lastIndexOf('/')-6)+'html/login.html';
            break;
    }
}

function getToken() {
    return get('xs_apptoken');
}

function getRybh() {
    return get('xs_rybh');
}

function getUserName() {
    return get('xs_xm');
}



//====================以下为通用方法, 尽量不编辑, 如需要增加对app支持修改以上内容即可========================


function ajaxReturn(controller, action, datas, callBack) {
    datas['rybh']=getRybh();
    datas['token']=getToken();
    $.showIndicator(); //显示加载框
    $.ajax({
        url: config.SERVER_URL+"&m="+controller+"&a="+action,
        dataType: "jsonp",
        data: datas,
        success: function (result) {
            $.hideIndicator(); //关闭加载框
            if(result && result.Code==9){
                $.toast(result.Msg);
                setTimeout(function () {
                    authError();
                }, 2000);
                return;
            }else if(result.Code==8){
				authError();
				return;
			}
            result.Msg=result.Msg==undefined?result.msg:result.Msg;
            callBack(result.Code, result.Msg, result.Data, result);
        },
        error: function () {
            $.hideIndicator();
        }
    });

}

function saveInfo(data) {
    set('xs_rybh', data.rybh);
    set('xs_xm', data.xm);
    set('xs_txzp', data.txzp);
    set('xs_rongtoken', data.rongtoken);
    set('xs_apptoken', data.apptoken);
}

function set(key, value) {
    var Storage=deepGet();
    Storage[key]=value;
    deepSet(Storage);
}

function get(key) {
    var Storage=deepGet();
    return Storage[key];
}

function setParam(param, value) {
    var Storage=deepGet();
    Storage['param_'+param]=value;
    deepSet(Storage);
}

function getParam(param) {
    var Storage=deepGet();
    return Storage['param_'+param];
}


function deepSet(storage) {
    store.set('zhxygzs_dybapp', storage);
}

function deepGet() {
    var Storage=store.get('zhxygzs_dybapp');
    if(Storage==undefined) {
        Storage = {};
        store.set('zhxygzs_dybapp', Storage);
    }
    return Storage;
}

function Import(file)
{
    document.write("<scri" + "pt src='"+file+"'></sc" + "ript>");
};


function getScriptRootPath() {
    var js = document.scripts;
    js = js[js.length - 1].src.substring(0, js[js.length - 1].src.lastIndexOf("/") + 1);
    return js;
}
